﻿function openFMWS(){
    var websocket = new WebSocket("wss://127.0.0.1:10000");
    websocket.binaryType = "arraybuffer";
    websocket.onmessage = function(evt) { onMessage(evt) };
    websocket.onerror = function(evt) { onError(evt) };
    websocket.onopen = function(evt) { onOpen(evt) };
    var rcd = document.getElementById("confirmrcd");
    rcd.addEventListener("click",RCD,false);
    var rls = document.getElementById("RemoteLS");
    rls.addEventListener("click",RLS,false);
    var dwnload = document.getElementById("download");
    dwnload.addEventListener("click",DOWNLOAD,false);
    var upld = document.getElementById("upload");
    upld.addEventListener("click",UPLOAD,false);
    var blob =  new Blob([""],{type: "application/octet-stream"});
    var nme;

    function onOpen(evt){
        var luser = document.getElementById("lusername").value;
        var ruser = document.getElementById("rusername").value;
        var pwd = document.getElementById("password").value;
        console.log("Connecting.. ");
        var packet = ("[CONN]"+"[11111]"+luser+"[11111]"+pwd);
        websocket.send(packet);
        console.log("Connected.");
    }
    function onMessage(evt) {
	  var luser = document.getElementById("lusername").value;
      if(evt.data.indexOf('[00000]')>=0){
        var ar = evt.data.split('[11111]');
        var cde = ar[0];
        console.log(cde);
        if (cde.indexOf("[RETLIST]")>=0){
          var dat = ar[1];
          document.getElementById("remo").value = evt.data;
          console.log(dat);
        }else if(cde.indexOf("[RETDOWN]")>=0){
          var da = evt.data.split('[00000]');
          if (evt.data.indexOf('[FILE TRANSFER COMPLETE]')>=0){
                        var xdat = evt.data.split("[22222]");
			var url = xdat[2];
			console.log("url:" + url);
			var x=new XMLHttpRequest();
			x.onreadystatechange = function() {
			  if (x.readyState == XMLHttpRequest.DONE) {
				websocket.send('[PURGE]'+"[11111]" + luser + "[11111]" + xdat[1]);
                console.log("Finshed...");
			  }
			}
			x.open("GET", url, true);
			x.responseType = 'blob';
			x.onload=function(e){download(x.response, xdat[1], "application/octet-stream" ); }
			console.log("Downloading...");
			x.send();
          }
    }
    }
    }
    function onError(evt) {
        console.log(evt);
    }


    function UPLOAD(){
        var luser = document.getElementById("lusername").value;
        var ruser = document.getElementById("rusername").value;
        var pwd = document.getElementById("password").value;
        var reader  = new FileReader();
        var file    = document.getElementById('uploadfile').files[0];
        reader.onloadend = function () {
            console.log("file name is " + file.name);
            var msg = reader.result.split(';base64,');
            var dat = msg[1];
            websocket.send("[UPLOAD]" + "[11111]" + ruser + "[11111]" + file.name + "[22222]" + dat);
            websocket.send("[UPLOAD]"+"[11111]"+ruser+"[11111]"+ "[FILE TRANSFER COMPLETE]" + "[22222]"+ "[NULL]");
            alert("file transferred!");
        }
        if (file) {
            reader.readAsDataURL(file);
        }
    }

    function RCD(){
      var luser = document.getElementById("lusername").value;
      var ruser = document.getElementById("rusername").value;
      var pwd = document.getElementById("password").value;
      var targetdir = document.getElementById("changeremotedir").value;
      websocket.send('[TRANSVERSE]'+"[11111]"+ ruser + "[11111]" + targetdir);
      RLS();
    }

    function RLS(){
      var luser = document.getElementById("lusername").value;
      var ruser = document.getElementById("rusername").value;
      var pwd = document.getElementById("password").value;
      websocket.send('[LIST]'+"[11111]"+ruser+"[11111]"+"[NULL]");
    }

    function DOWNLOAD(){
      var luser = document.getElementById("lusername").value;
      var ruser = document.getElementById("rusername").value;
      var pwd = document.getElementById("password").value;
      var targetdir = document.getElementById("downloadfile").value;
      websocket.send('[DOWNLOAD]'+"[11111]" + ruser + "[11111]" + targetdir);
    }
}
