from Tkinter import *
import sys
import base64
import os
from autobahn.twisted.websocket import WebSocketClientProtocol, \
    WebSocketClientFactory, \
    connectWS
import io
from PIL import Image, ImageTk
from twisted.python import log
from twisted.internet import reactor, ssl
from twisted.internet import tksupport
from twisted.internet.task import LoopingCall
lid = sys.argv[2]
rid = sys.argv[3]
passwd = sys.argv[4]
#three class lists: each class will have a communication global.
cmaster = [] # for the GUI core
pmaster = [] # for the websocket
rmaster = [] # for the root class
class RAPTORRDP(WebSocketClientProtocol):
    def onConnect(self, response):
        pmaster.append(self)
        print("Server connected: {0}".format(response.peer))
        self.sendMessage(("[CONN]"+"[11111]"+lid+"[11111]"+passwd).encode('utf8'))

    def onOpen(self):
        pass

    def REQ(self):
        self.sendMessage(('[SCRREQ][11111]' + rid + '[11111]' + "[NULL]").encode('utf8'))

    def onMessage(self, payload, isBinary):
        global display # this must be global
        if isBinary:
            pass
        else:
            msg = payload.decode('utf8')
            comm, d = msg.split("[00000]")
            print comm
            if comm == ("[IMAGE]"):
                try:
                    print ("image")
                    w, h, data = d.split("[22222]")
                    w = float(w)
                    h = float(h)
                    w = int(w)
                    h = int(h)
                    print (w,h)
                    data = base64.b64decode(data)
                    imgdata = io.BytesIO(data)
                    img = Image.open(imgdata)
                    display = ImageTk.PhotoImage(img)
                    for target in cmaster:
                        target.canvas.config(width=w, height=h, image=display)
                    for rt in rmaster:
                        rt.root.geometry(str(w)+"x"+str(h)+"+300+300")

                except Exception as e:
                    print e 
            elif comm == ("[RETCONN]"):
                print d
                req = LoopingCall(self.REQ)
                req.start(2.5)



    def onClose(self, wasClean, code, reason):
        print("WebSocket connection closed: {0}".format(reason))


class main():
    def __init__(self):
        rmaster.append(self)
        self.root = Tk()
        self.root.geometry("100x100+300+300")
        self.root.title("RAPTORV")
        tksupport.install(self.root)
        self.canvas = Canvas_Manager(self.root)
        self.root.protocol("WM_DELETE_WINDOW", self.w.destroy_Canvas_Manager)
        log.startLogging(sys.stdout)


class Canvas_Manager():
    def __init__(self, master=None):
        global display # problems with tk require this to be global
        display = ""
        cmaster.append(self)
        self.canvas= Label(master, width=100, height=100,image=display)
        self.canvas.image = display
        self.canvas.bind("<Key>", self.key) #bind events
        self.canvas.bind("<Button-1>", self.leftcallback)
        self.canvas.bind("<Button-3>", self.rightcallback)
        self.canvas.bind("<ButtonRelease-1>", self.leftrelease)
        self.canvas.bind("<ButtonRelease-3>", self.rightrelease)
        self.canvas.bind("<Double-Button-1>", self.leftdouble)
        self.canvas.bind("<Double-Button-3>", self.rightdouble)
        self.canvas.pack()
        self.factory = WebSocketClientFactory("wss://"+sys.argv[1]+":9000")
        self.factory.protocol = RAPTORRDP
        contextFactory = ssl.ClientContextFactory()
        connectWS(self.factory, contextFactory)
        reactor.run()
        
    def destroy_Canvas_Manager(self):
        os._exit(1)
    
    def key(self,event): #thank you stackoverflow!
        print "pressed", (event.keysym)
        # The obvious information
        c = event.keysym
        s = event.state

        # Manual way to get the modifiers
        ctrl  = (s & 0x4) != 0
        alt   = (s & 0x8) != 0 or (s & 0x80) != 0
        shift = (s & 0x1) != 0

        # Merge it into an output
        if alt:
            command = ('ALT' + '[22222]'  + event.keysym + '[22222]' + '[NULL]')
            packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
            for target in pmaster:
                self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
        elif shift:
            if event.keysym == "asciitilde":
                command = ("SHIFT" + "[22222]" + "`" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "exclam":
                command = ("SHIFT" + "[22222]" + "1" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "at":
                command = ("SHIFT" + "[22222]" + "2" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "numbersign":
                command = ("SHIFT" + "[22222]" + "3" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "dollar":
                command = ("SHIFT" + "[22222]" + "4" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "percent":
                command = ("SHIFT" + "[22222]" + "5" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "asciicircum":
                command = ("SHIFT" + "[22222]" + "6" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "ampersand":
                command = ("SHIFT" + "[22222]" + "7" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "asterisk":
                command = ("SHIFT" + "[22222]" + "8" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "parenleft":
                command = ("SHIFT" + "[22222]" + "9" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "parenright":
                command = ("SHIFT" + "[22222]" + "0" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "underscore":
                command = ("SHIFT" + "[22222]" + "-" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "plus":
                command = ("SHIFT" + "[22222]" + "=" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "braceleft":
                command = ("SHIFT" + "[22222]" + "[" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "braceright":
                command = ("SHIFT" + "[22222]" + "]" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "bar":
                command = ("SHIFT" + "[22222]" + "\\" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "colon":
                command = ("SHIFT" + "[22222]" + ";" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "quotedbl":
                command = ("SHIFT" + "[22222]" + "'" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "less":
                command = ("SHIFT" + "[22222]" + "," + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "greater":
                command = ("SHIFT" + "[22222]" + "." + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "question":
                command = ("SHIFT" + "[22222]" + "/" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            else:
                command = ('SHIFT' + '[22222]'  + event.keysym + '[22222]' + '[NULL]')
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
        elif ctrl:
            command = ('CTRL' + '[22222]'  + event.keysym + '[22222]' + '[NULL]')
            packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
            for target in pmaster:
                self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
        else:
            if event.keysym == "BackSpace":
                command = ("BACKSPACE" + "[22222]" + "[NULL]" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "Return":
                command = ("RETURN" + "[22222]" + "[NULL]" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "space":
                command = ("SPACE" + "[22222]" + "[NULL]" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "minus":
                command = ("-" + "[22222]" + "[NULL]" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "equal":
                command = ("=" + "[22222]" + "[NULL]" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "period":
                command = ("." + "[22222]" + "[NULL]" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "slash":
                command = ("/" + "[22222]" + "[NULL]" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "semicolon":
                command = (";" + "[22222]" + "[NULL]" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "comma":
                command = ("," + "[22222]" + "[NULL]" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "grave":
                command = ("`" + "[22222]" + "[NULL]" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "bracketleft":
                command = ("[" + "[22222]" + "[NULL]" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "backslash":
                command = ("\\" + "[22222]" + "[NULL]" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            elif event.keysym == "bracketright":
                command = ("]" + "[22222]" + "[NULL]" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
            else:
                command = (event.keysym + "[22222]" + "[NULL]" + "[22222]" + "[NULL]")
                packet = ("[COMMAND]"+"[11111]"+rid + '[11111]' + command)
                for target in pmaster:
                    self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
    def leftcallback(self,event):
        self.canvas.focus_set()
        print "clicked at", event.x, event.y
        command = ("LEFTC" + "[22222]" + str(event.x) + "[22222]" + str(event.y))
        packet = ("[COMMAND]"+"[11111]"+ rid + '[11111]' + command)
        for target in pmaster:
            self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
        
    def rightcallback(self,event):
        self.canvas.focus_set()
        print "clicked at", event.x, event.y
        command = ("RIGHTC" + "[22222]" + str(event.x) + "[22222]" + str(event.y))
        packet = ("[COMMAND]"+"[11111]"+ rid + '[11111]' + command)
        for target in pmaster:
            self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
        
    def leftrelease(self,event):
        self.canvas.focus_set()
        print "release at", event.x, event.y
        command = ("RELEASE" + "[22222]" + str(event.x) + "[22222]" + str(event.y))
        packet = ("[COMMAND]"+"[11111]"+ rid + '[11111]' + command)
        for target in pmaster:
            self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
        
    def rightrelease(self,event):
        self.canvas.focus_set()
        print "release at", event.x, event.y
        command = ("RELEASE" + "[22222]" + str(event.x) + "[22222]" + str(event.y))
        packet = ("[COMMAND]"+"[11111]"+ rid + '[11111]' + command)
        for target in pmaster:
            self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
        
    def leftdouble(self,event):
        self.canvas.focus_set()
        print "double at", event.x, event.y
        command = ("DBLLEFTC" + "[22222]" + str(event.x) + "[22222]" + str(event.y))
        packet = ("[COMMAND]"+"[11111]"+ rid + '[11111]' + command)
        for target in pmaster:
            self.factory.protocol.sendMessage(target,(packet).encode('utf8'))

    def rightdouble(self,event):
        self.canvas.focus_set()
        print "double at", event.x, event.y
        command = ("DBLRIGHTC" + "[22222]" + str(event.x) + "[22222]" + str(event.y))
        packet = ("[COMMAND]"+"[11111]"+ rid + '[11111]' + command)
        for target in pmaster:
            self.factory.protocol.sendMessage(target,(packet).encode('utf8'))
    


main()
