import sys
import time
import subprocess
import os
import shutil
import ConfigParser
def darwin_stage1():
    try:
        subprocess.call("pyinstaller -F -w Professional-Edition/RAPTORRDP.py",shell=True)
        subprocess.call("pyinstaller -F -w hfile/hfile.py",shell=True)
        subprocess.call("pyinstaller -F -w Host/Host.py",shell=True)
        subprocess.call("pyinstaller -F -w dirmanager/dirmanager.py",shell=True)
        subprocess.call("pyinstaller -F -w RAPTORV/RAPTORV.py",shell=True)
        shutil.copytree("dist/RAPTORRDP.app","RAPTORRDP.app")
        os.mkdir("RAPTORRDP.app/Contents/MacOS/hfile")
        os.mkdir("RAPTORRDP.app/Contents/MacOS/Host")
        os.mkdir("RAPTORRDP.app/Contents/MacOS/dirmanager")
        os.mkdir("RAPTORRDP.app/Contents/MacOS/RAPTORV")
        shutil.move("dist/hfile","RAPTORRDP.app/Contents/MacOS/hfile/hfile")
        shutil.move("dist/Host","RAPTORRDP.app/Contents/MacOS/Host/Host")
        shutil.move("dist/dirmanager","RAPTORRDP.app/Contents/MacOS/dirmanager/dirmanager")
        shutil.move("dist/RAPTORV","RAPTORRDP.app/Contents/MacOS/RAPTORV/RAPTORV")
        shutil.rmtree("dist")
        shutil.rmtree("build")
    except Exception as e:
        print str(e)
        time.sleep(5)
        sys.exit()
    darwin_stage2()

def darwin_stage2():
    try:
        parser = ConfigParser.SafeConfigParser()
        parser.read('CONFIG/config.ini')
        parser.set('server','url',SITE)
        with open('CONFIG/config.ini', 'wb') as configfile:
            parser.write(configfile)
        shutil.copy('CONFIG/config.ini',"RAPTORRDP.app/Contents/MacOS/config.ini")
    except Exception as e:
        print str(e)
        time.sleep(5)
        sys.exit()
    print("Build Completed!")

def lin_stage1():
     #stage 1 creates build directory
     try:
         os.mkdir("RAPTOR-FULL")
         os.mkdir("RAPTOR-FULL/hfile")
         os.mkdir("RAPTOR-FULL/Host")
         os.mkdir("RAPTOR-FULL/dirmanager")
         os.mkdir("RAPTOR-FULL/RAPTORV")
     except Exception as e:
         print str(e)
         time.sleep(5)
         sys.exit()
     lin_stage2()
     
     
def lin_stage2():
     #stage 2 builds hfile,Host and GUI and copies them to correct directories
     try:
         subprocess.call("pyinstaller -F -w hfile/hfile.py",shell=True)
         shutil.move("dist/hfile","RAPTOR-FULL/hfile/hfile")
         subprocess.call("pyinstaller -F -w Host/Host.py",shell=True)
         shutil.move("dist/Host","RAPTOR-FULL/Host/Host")
         subprocess.call("pyinstaller -F -w dirmanager/dirmanager.py",shell=True)
         shutil.move("dist/dirmanager","RAPTOR-FULL/dirmanager/dirmanager")
         subprocess.call("pyinstaller -F -w RAPTORV/RAPTORV.py",shell=True)
         shutil.move("dist/RAPTORV","RAPTOR-FULL/RAPTORV/RAPTORV")
         subprocess.call("pyinstaller -F -w Professional-Edition/RAPTORRDP.py",shell=True)
         shutil.move("dist/RAPTORRDP","RAPTOR-FULL/RAPTORRDP")
     except Exception as e:
         print str(e)
         time.sleep(5)
         sys.exit()
     lin_stage3()

def lin_stage3():
     #modify default configuration file and pack build.
     try:
          parser = ConfigParser.SafeConfigParser()
          parser.read('CONFIG/config.ini')
          parser.set('server','url',SITE)
          with open('CONFIG/config.ini', 'wb') as configfile:
               parser.write(configfile)
          shutil.copy('CONFIG/config.ini',"RAPTOR-FULL/config.ini")
          print("Archiving Linux build. One moment please.")
          subprocess.call("zip -r RAPTORLinux-FULL.zip RAPTOR-FULL/",shell=True)
     except Exception as e:
          print str(e)
          time.sleep(5)
          sys.exit()
     print("Build Completed!")
    
def win32_stage1():
    try:
        os.mkdir("TEMP")
        subprocess.call("python hfile/hfilesetup.py build",shell=True)
        shutil.copytree("build/exe.win32-2.7/","TEMP/hfile/")
        shutil.rmtree("build/exe.win32-2.7/")
        subprocess.call("python Host/Hostsetup.py build",shell=True)
        shutil.copytree("build/exe.win32-2.7/","TEMP/Host/")
        shutil.rmtree("build/exe.win32-2.7/")
        subprocess.call("python RAPTORV/RAPTORVsetup.py build",shell=True)
        shutil.copytree("build/exe.win32-2.7/","TEMP/RAPTORV/")
        shutil.rmtree("build/exe.win32-2.7/")
        subprocess.call("python dirmanager/dirmanagersetup.py build",shell=True)
        shutil.copytree("build/exe.win32-2.7/","TEMP/dirmanager/")
        shutil.rmtree("build/exe.win32-2.7/")
        subprocess.call(["python","C:\Python27\Scripts\cxfreeze","Professional-Edition/RAPTORRDP.py", "--base-name=Win32GUI"],shell=True)
        subprocess.call("python Host/RBOTsetup.py build",shell=True)
        shutil.copytree("build/exe.win32-2.7/","TEMP/winsysi")
        shutil.copytree("Host\Winsysi-java-prebuilt/exec","dist/winsysi/exec")
        shutil.copytree("TEMP/hfile/","dist/hfile/")
        shutil.copytree("TEMP/Host/","dist/Host/")
        shutil.copytree("TEMP/dirmanager/","dist/dirmanager/")
        shutil.copytree("TEMP/RAPTORV/","dist/RAPTORV/")
        print("You now need to tell me where your java JRE is located.\n You must use a 32-bit build of java JRE at this time, as 64-bit JRe is untested.\n\n")
        pth = raw_input("path:\n")
        shutil.copytree(pth,"dist/winsysi/jre")
    except Exception as e:
        print str(e)
        shutil.rmtree("build")
        shutil.rmtree("TEMP")
        time.sleep(5)
        sys.exit()
    win32_stage2()

def win32_stage2():
    try:
        parser = ConfigParser.SafeConfigParser()
        parser.read('CONFIG/config.ini')
        parser.set('server','url',SITE)
        with open('CONFIG/config.ini', 'wb') as configfile:
            parser.write(configfile)
        shutil.copy('CONFIG/config.ini',"dist/config.ini")
        os.rename("dist","RAPTOR-FULL")
        f = open ("RAPTOR-FULL/README.txt","wb").write("Extract files to C:\RAPTORRDP and run install.cmd as Administrator. It will take care of the rest.")
        shutil.copy("windows-installer-tools/install.cmd","RAPTOR-FULL/install.cmd")
    except Exception as e:
        print str(e)
        shutil.rmtree("build")
        shutil.rmtree("TEMP")
        time.sleep(5)
        sys.exit()
    print("Build Completed! All you need to do is zip and ship!\n")
    shutil.rmtree("build")
    shutil.rmtree("TEMP")
    time.sleep(5)
    sys.exit()


SITE = raw_input("Please enter FQDN or IP where you will be hosting the servers:\n")

if sys.platform == "linux" or sys.platform == "linux2":
    try:
        from twisted.internet import reactor
        from autobahn.twisted.websocket import *
        #import pygame
        import Tkinter
        import ttk
        import pyautogui
        import cffi
        import cryptography
        from PIL import Image, ImageTk
        from OpenSSL import SSL
        import psutil
        import PyInstaller
    except Exception as e:
        print str(e)
        time.sleep(5)
        sys.exit()
    lin_stage1()
elif sys.platform == "darwin":
    sure = raw_input("XCODE and homebrew with python 2.7 must be installed along with Xcode eula command line accepted. Have you done this? Y/N")
    if sure == "Y" or "y":
        try:
            from twisted.internet import reactor
            from autobahn.twisted.websocket import *
            #import pygame
            import Tkinter
            import ttk
            import pyautogui
            import cffi
            import cryptography
            from PIL import Image, ImageTk
            from OpenSSL import SSL
            import psutil
            import PyInstaller
        except Exception as e:
            print str(e)
            time.sleep(5)
            sys.exit()
        darwin_stage1()
elif sys.platform == "win32":
    try:
        import win32com
        from twisted.internet import reactor
        from autobahn.twisted.websocket import *
        #import pygame
        import psutil
        import Tkinter
        import ttk
        import cx_Freeze
        import pyautogui
        import cffi
        import cryptography
        from PIL import Image, ImageTk
        from OpenSSL import SSL
    except Exception as e:
        print str(e)
        time.sleep(5)
        sys.exit()
    win32_stage1()



