import sys
import time
import subprocess
import os
import shutil


def lin_stage1():
     #stage 1 creates build directory
     try:
         shutil.copytree('LINUXSERVERS/','RAPTORServer/')
         os.remove('RAPTORServer/README-SERVERS.txt')
     except Exception as e:
         print str(e)
         time.sleep(5)
         sys.exit()
     lin_stage2()

def lin_stage2():
     #stage 2 sets up our ssl keys. You will end up with self-signed keys. this will also confiigure the webpage.
     try:
         subprocess.call("openssl req -newkey rsa:4096 -new -nodes -x509 -days 3650 -keyout server.key -out server.pem",shell=True)
         shutil.copy("server.key","RAPTORServer/keys/server.key")
         shutil.copy("server.pem","RAPTORServer/keys/server.pem")
         #webserver requires cert in different format...
         os.rename("server.pem","server.crt")
         subprocess.call("cat server.key > server.pem",shell=True)
         subprocess.call("cat server.crt >> server.pem",shell=True)
         shutil.move("server.pem","RAPTORServer/webserver/keys")
         print("reconfiguring website... now...")
         f1 = open('RAPTORServer/webserver/index/assets/js/RAPTORCONNECT.js', 'rb')
         f2 = open('RAPTORServer/webserver/index/assets/js/RAPTORCONNECT.js.tmp', 'wb')
         for line in f1:
             f2.write(line.replace('127.0.0.1',SITE))
         f1.close()
         f2.close()
         shutil.move('RAPTORServer/webserver/index/assets/js/RAPTORCONNECT.js.tmp','RAPTORServer/webserver/index/assets/js/RAPTORCONNECT.js')
         f1 = open('RAPTORServer/webserver/index/assets/js/fm.js', 'rb')
         f2 = open('RAPTORServer/webserver/index/assets/js/fm.js.tmp', 'wb')
         for line in f1:
             f2.write(line.replace('127.0.0.1',SITE))
         f1.close()
         f2.close()
         shutil.move('RAPTORServer/webserver/index/assets/js/fm.js.tmp','RAPTORServer/webserver/index/assets/js/fm.js')
     except Exception as e:
         print str(e)
         time.sleep(5)
         sys.exit()
     
     lin_stage3()

def lin_stage3():
    #archive and attempt to install server.
    try:
        print("Archiving Linux server build. One moment please.")
        subprocess.call("zip -r RAPTORServerLinux.zip RAPTORServer/",shell=True)
        print("Build complete!")
        inst = raw_input("Would you like to install? Script must be running with root privs to continue. Y/N \n")
        if inst == ("Y"):
            shutil.copytree("RAPTORServer/","/opt/RAPTORServer")
            print("Installed!")
        else:
            print("Install Declined!")
    except Excpetion as e:
        print str(e)
        time.sleep(5)
        sys.exit()
SITE = raw_input("Please enter FQDN or IP where you will be hosting the servers:\n")

if sys.platform == "linux" or sys.platform == "linux2":
    try:
        from twisted.internet import reactor
        from autobahn.twisted.websocket import *
        import pygame
        import Tkinter
        import ttk
        import pyautogui
        import cffi
        import cryptography
        from PIL import *
        from OpenSSL import SSL
        import psutil
        import PyInstaller
    except Exception as e:
        print str(e)
        time.sleep(5)
        sys.exit()
    lin_stage1()
elif sys.platform == "darwin":
    print("MACOS Support for server not yet tested")
    time.sleep(5)
    sys.exit()
elif sys.platform == "win32":
    print("server is not desigend to work on windows!")
    time.sleep(5)
    sys.exit()
